/*
 * Else.c 
 *
 * Created: 16.03.2014 
 *  Author: Jenny

 *
 *	
 *	Codesize:
 *		release
 *	Pgm	1912
 *	RAM	128
 *    EEPROM 0
 *	
 */ 

//#define Testmode 1 //PB0 ist Debug-Ausgang
/*
//TESTPIN********************************************************************************************************
#ifdef Testmode 
	PORTB = PORTB & ~(1<< 0); //Debug-Pin ausschalten
#endif
//TESTPIN********************************************************************************************************
#ifdef Testmode
	PORTB = PORTB | (1<< 0);//Debug-Pin einschalten
#endif
*/

/*------------------------------------------------------------
//Pegelabhngige Schaltfunktion (Werners Lipowchter)
#define LED_max 4 //Anzahl der LEDs
#define Sequenz_max 3//Anzahl der Modis, die durch die PWM selektierbar sind
#define Pegel_max 1 //Anzahl der Pegeleingnge
#define Flash_max 3
#define Clock_Speed 8000000 //8MHz CPU-Frequenz
#define Zyklus_Interrupt 240 //Abtastrate 30us/33,3kHz

#define blinktimer_max 0x0040 //tmin=3,7ms, Fmax=133Hz
#define eeprom_log 1 //Schaltet EEPROM-Log ein

#define port_Pegel1 4
#define port_LED1 0
#define port_LED2 1
#define port_LED3 2
#define port_LED4 3
*/
//------------------------------------------------------------
#define LED_max 4 //Anzahl der LEDs
#define Sequenz_max 3//Anzahl der Modis, die durch die PWM selektierbar sind
#define PWM_max 1 //Anzahl der PWMs
//#define PWM_max2 0 //Flag, dass zweite PWM-Routine erstellt werden soll
//#define PWM_software 1//Flag, dass die PWM per Software ausgewertet wird
#define PWM_hardware 1//Flag, dass die PWM per Hardware (Timer1) ausgewertet wird
#define Flash_max 3
#define Clock_Speed 8000000 //8MHz CPU-Frequenz
#define Zyklus_Interrupt 240 //Abtastrate 30us/33,3kHz

#define blinktimer_max 0x0040 //tmin=3,7ms, Fmax=133Hz
//#define eeprom_log 1 //Schaltet EEPROM-Log ein

//Port Belegung Else, uElse Testboard und Pro Control
#define port_PWM1 4
//#define port_PWM2 4
//#define port_Pegel1 4
#define port_LED1 0
#define port_LED2 1
#define port_LED3 2
#define port_LED4 3
/*------------------------------------------------------------
#define LED_max 4 //Anzahl der LEDs
#define Sequenz_max 3//Anzahl der Modis, die durch die PWM selektierbar sind
#define Pegel_max 1 //Anzahl der Pegeleingnge
//#define PWM_max 1 //Anzahl der PWMs
//#define PWM_max2 0 //Flag, dass zweite PWM-Routine erstellt werden soll
//#define PWM_software 1//Flag, dass die PWM per Software ausgewertet wird
//#define PWM_hardware 1//Flag, dass die PWM per Hardware (Timer1) ausgewertet wird
#define Flash_max 3
#define Clock_Speed 8000000 //8MHz CPU-Frequenz
#define Zyklus_Interrupt 240 //Abtastrate 30us/33,3kHz

#define blinktimer_max 0x0040 //tmin=3,7ms, Fmax=133Hz
#define eeprom_log 1 //Schaltet EEPROM-Log ein

//Port Belegung Else, uElse Testboard und Pro Control
//#define port_PWM1 4
//#define port_PWM2 4
#define port_Pegel1 4
#define port_LED1 0
#define port_LED2 1
#define port_LED3 2
#define port_LED4 3
*/
//------------------------------------------------------------

#define _NOP() __asm__ __volatile__ ("nop")


#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

#include <inttypes.h>
struct Verhalten_typ
{
	uint8_t Schwelle[Sequenz_max];
	uint8_t Drehbuch[Sequenz_max][LED_max];
};

struct PWM_typ
{
	uint8_t  Port_pin;
	uint8_t State; //0=paused, 1=aktiv
	uint8_t Tick_cnt;
	uint8_t Tick_value;
	uint8_t Error; //Anzahl der Fehlmessungen
};

struct Timing_typ 
{
	unsigned int time_cnt;
	unsigned int time_max;
};

struct LED_typ
{
	uint8_t Port_pin;
	uint8_t Funktion; //0=aus, 1=ein, 2=blinken/blitzen
	uint8_t State; //0..3=Flash,8=off, 9=on,10=Jet
	struct Timing_typ Timing[Flash_max *2];
};

#ifdef eeprom_log
//Memorymap fr EEPROM
uint8_t EEinit EEMEM=0x00; //Flag dass EEPROM initialisiert ist
#ifdef PWM_max
struct PWM_typ EE_PWM1 EEMEM = {port_PWM1,0x00,0x00,0x00,0x00};

#ifdef PWM_max2
struct PWM_typ EE_PWM2 EEMEM = {port_PWM2,0x00,0x00,0x00,0x00};
#endif	

#else
struct PWM_typ EE_PWM1 EEMEM = {0x00,0x00,0x00,0x00,0x00};
struct PWM_typ EE_PWM2 EEMEM = {0x00,0x00,0x00,0x00,0x00};
#endif

struct Verhalten_typ EE_Verhalten = {{133,166,200},{{0,0,0,0},{1,0,1,1},{1,1,1,1}}};
struct LED_typ EE_LED1 EEMEM = {port_LED1,0x02,0x00,{{0,540},{0,30},{0,120},{0,20},{0,60},{0,10}}}; //ACL Dreifachblitz
struct LED_typ EE_LED2 EEMEM = {port_LED2,0x00,0x00,{{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}}}; //Landescheinwerfer, Positionslichter
struct LED_typ EE_LED3 EEMEM = {port_LED3,0x02,0x00,{{0,0x0300},{0,0x0020},{0,0x0040},{0,0x0020},{0,0},{0,0}}};//ACL Doppelblitz
struct LED_typ EE_LED4 EEMEM = {port_LED4,0x02,0x00,{{0,0},{0,0x0030},{0,630},{0,0},{0,0},{0,0}}};
#endif


//Variablen
#ifdef PWM_max
volatile struct PWM_typ PWM[PWM_max];
#endif
volatile unsigned int blinktimer;
volatile struct LED_typ LED[LED_max];
volatile struct LED_typ *LED_ptr;
volatile struct PWM_typ *PWM_ptr;
//volatile struct Verhalten_typ Verhalten;

#ifdef PWM_hardware
uint8_t PWM_aktiv;
#endif

volatile struct 
{
	volatile int counter;
	volatile int min;
	volatile int max;
} Idle;


#ifdef eeprom_log
void EEPROM_init(void)
{
	#ifdef PWM_max
	PWM[0]=EE_PWM1;
	#endif
	
	#ifdef PWM_max2
	PWM[1]=EE_PWM2;
	#endif
	
	LED[0]=EE_LED1;
	LED[1]=EE_LED2;
	LED[2]=EE_LED3;
	LED[3]=EE_LED4;
	Verhalten=EE_Verhalten;

	return;
}
#endif

#ifdef eeprom_log
void Verhalten_init()
{
//struct Verhalten_typ EE_Verhalten = {{133,166,200},{{0,0,0,0},{1,0,1,1},{1,1,1,1}}};
	return;
}
#endif 

void LED_Flash_init(uint8_t LED_Nummer, uint8_t Port, uint16_t off1, uint16_t on1, uint16_t off2, uint16_t on2, uint16_t off3, uint16_t on3)
{
	LED[LED_Nummer].Funktion=2;
	LED[LED_Nummer].Port_pin=Port;
	LED[LED_Nummer].State=0;
	LED[LED_Nummer].Timing[0].time_cnt=0;
	LED[LED_Nummer].Timing[0].time_max=off1;
	LED[LED_Nummer].Timing[1].time_cnt=0;
	LED[LED_Nummer].Timing[1].time_max=on1;//On
	LED[LED_Nummer].Timing[2].time_cnt=0;
	LED[LED_Nummer].Timing[2].time_max=off2;//Off;
	LED[LED_Nummer].Timing[3].time_cnt=0;
	LED[LED_Nummer].Timing[3].time_max=on2;//On
	LED[LED_Nummer].Timing[4].time_cnt=0;
	LED[LED_Nummer].Timing[4].time_max=off3;//Off
	LED[LED_Nummer].Timing[5].time_cnt=0;
	LED[LED_Nummer].Timing[5].time_max=on3;//On
	return;
}

void LED_On_init(uint8_t LED_Nummer, uint8_t Port)
{
	uint8_t n; //Zhler
	
	LED[LED_Nummer].Funktion=1;
	LED[LED_Nummer].Port_pin=Port;
	LED[LED_Nummer].State=0;
	
	for (n=0;n<Flash_max*2;n++)
	{
		LED[LED_Nummer].Timing[n].time_cnt=0;
		LED[LED_Nummer].Timing[n].time_max=0;
	}
	return;
}

void LED_init(void)
{
	LED_Flash_init(0, port_LED1, 540, 30, 120, 20, 60, 10); //ACL-Dreifachblitz
	LED_Flash_init(1, port_LED2, 0, 0x0030, 630, 0, 0, 0); //ACL-Einfachblitz Vorbelegung wenn Landescheinwerfer blitzen soll
	//LED_On_init(1,port_LED2); //Landescheinwerfer
	LED_Flash_init(2, port_LED3, 768, 32, 64, 32, 0, 0); //ACL-Doppelblitz
	LED_Flash_init(3, port_LED4, 0, 0x0030, 630, 0, 0, 0); //ACL-Einfachblitz
	//LED_Flash_init(0, port_LED1, 0x0400, 0x0030, 0x0040, 0x0010, 0x0020, 0x0001); //Doppelblitz mit Nachzndung
	//LED_Flash_init(3, port_LED4, 0, Random_uint16_t(), 630, 0, 0, 0); //ACL-Einfachblitz Random ///Ungetestet
	//LED_Flash_init(0, port_LED1, 540, 30, 120, 20, 60, 10); //ACL-Blinken

	#ifdef eeprom_log
	eeprom_update_block ((void *)&LED[0], (void *)&EE_LED1, sizeof(LED[0])*4);	//prfen
	//EE_LED1=LED[0]; //geht nicht
	//EE_LED2=LED[1];//geht nicht
	//EE_LED3=LED[2];//geht nicht
	//EE_LED4=LED[3];//geht nicht
	#endif
	
	return;
}

uint16_t Random_uint16_t(void)
{
	static uint16_t y=7;
	y^=(y<<13);
	y=(y>>9);
	return (y^=(y<<5));
}

void PORT_init(void)
{
	  unsigned char temp;
	  #ifdef Testmode
		temp = 0xFF & ~(1<<port_LED1) & ~(1<<port_LED2) & ~(1<<port_LED3) & ~(1<<port_LED4) & ~(1<<PB0); //NURTEST
	  #else
		temp = 0xFF & ~(1<<port_LED1) & ~(1<<port_LED2) & ~(1<<port_LED3) & ~(1<<port_LED4);
	  #endif
	  PORTB= temp; //Default fr PortB: all Outputs will be 0, all Inputs gets internal pullups
	  DDRB = ~temp; //Set PortB for Input/Output
	  
	return;
}


void LED_chg(volatile struct LED_typ *LED_ptr,uint8_t On_Off)
{
	if(On_Off==0)
		{
		PORTB = PORTB & ~(1<< LED_ptr->Port_pin); 
		}
	else
		{
		PORTB = PORTB | (1<< LED_ptr->Port_pin);
		}
	return;
}

void LED_job(uint8_t Kanal)
{
	
	
	LED_ptr=&LED[Kanal];
	

		switch (LED_ptr->Funktion)
		{
			case 0x00: //Aus
			{
			LED_chg(LED_ptr,0);				
			return;
			}
			
			case 0x01: //Ein
			{
			LED_chg(LED_ptr,1);
			return;
			}

			case 0x02: //Blinken&Flash 1..3
			{
				if (LED_ptr->Timing[LED_ptr->State].time_cnt==0)
					//Timer abgelaufen, bergang zu nchsten State
					{
					LED_ptr->Timing[LED_ptr->State].time_cnt=LED_ptr->Timing[LED_ptr->State].time_max;//Abgelaufenen Timer wieder aufziehen, fr nchsten Zyklus
					if (LED_ptr->State !=Flash_max * 2-1)//prfen ob es der letzte State war
						//Nchster State
						{LED_ptr->State++;}
					else
						//State ist State0
						{LED_ptr->State=0;}	
						
					if (LED_ptr->Timing[LED_ptr->State].time_cnt!=0)//Ist der neue Timer des neuen States nicht 0?
						{
						LED_chg(LED_ptr,LED_ptr->State & 0x01); //LED ein- oder ausschalten
						}						
					}
				else
					//Timer ablaufen lassen.
					{
					LED_ptr->Timing[LED_ptr->State].time_cnt--;	
					}
				return;
			}

			
			case 0x03: //Random
			{	
				if (LED_ptr->Timing[LED_ptr->State].time_cnt==0)
				//Timer abgelaufen, bergang zu nchsten State
				{
					LED_ptr->Timing[LED_ptr->State].time_cnt=Random_uint16_t();//Abgelaufenen Timer wieder aufziehen, fr nchsten Zyklus
					if (LED_ptr->State !=Flash_max * 2-1)//prfen ob es der letzte State war
					//Nchster State
					{LED_ptr->State++;}
					else
					//State ist State0
					{LED_ptr->State=0;}
					
					if (LED_ptr->Timing[LED_ptr->State].time_cnt!=0)//Ist der neue Timer des neuen States nicht 0?
					{
						LED_chg(LED_ptr,LED_ptr->State & 0x01); //LED ein- oder ausschalten
					}
				}
				else
				//Timer ablaufen lassen.
				{
					LED_ptr->Timing[LED_ptr->State].time_cnt--;
				}

				return;
			}			
			default:
			{return;} //Fehlerfall
		}
}



void Timer0_init(void)
{
	cli();
	#ifdef _AVR_IOM16_H_
	//Mega16:
	//CTC-Mode 4 (0100), OCR1A=top, update immediate max
	TCCR0=0b00001001;
	TCNT0=0x00;
	OCR0=Zyklus_Interrupt;
	TIMSK=0b00000010;
	#endif
	#ifdef _AVR_IOTN85_H_	
	//Tiny85
	GTCCR |= (1<<PSR0);//3.11.2013
	TCCR0A |= (1<<WGM01);
	TCCR0B |= (1<<CS00); //no prescaler
	TCNT0=0x00;
	OCR0A=Zyklus_Interrupt; //Timerwert
	TIMSK |= (1<<OCIE0A);  
	#endif
	sei();
	blinktimer=blinktimer_max;
	return;	
}

#ifdef PWM_hardware
void Timer1_init(void)
{
	cli();
	#ifdef _AVR_IOM16_H_
	//Mega16:
	//CTC-Mode 4 (0100), OCR1A=top, update immediate max
	TCCR1=0b00001001;//ungeprft
	TCNT1=0x00;//ungeprft
	//OCR0=Zyklus_Interrupt; 
	TIMSK=0b00000010; //ungeprft
	#endif
	
	#ifdef _AVR_IOTN85_H_
	//Tiny85
	TCCR1 &= 0x00; //Timer/Counter, angehalten, keine Verbindung zu Pin 
	TCCR1 |= (1<<CS13); //prescaler =128, f=62500Hz 62,5<t<125 @100%
	
	//Timer auf 0 stellen:
	GTCCR |= (1<<PSR1);//Vorteiler Reset
	TCNT1=0x00;//Timer auf 0 setzen
	//TIMSK |= (1<<TOIE1);//Interrupt bei berlauf 
	#endif
	
	sei();
	return;
}
#endif

#ifdef PWM_hardware
#ifdef PWM_max
void IRQonCHG_init(void)
{
	cli();
	#ifdef _AVR_IOM16_H_
	//Mega16:
	#endif
	#ifdef _AVR_IOTN85_H_
	//Tiny85
	PWM_aktiv=0; //Erste PWM aktivieren
	PWM_ptr=&PWM[PWM_aktiv]; //Pointer belegen
	PCMSK |= (1<<PWM_ptr->Port_pin); //Sensiblen Pin einschalten
	GIMSK |= (1<<PCIE); //Pin Change Interrupt Enable
	GIFR |= (1<<PCIF);
	#endif
	sei();
	return;
}
#endif
#endif

/*------------------------------------------------------------------------------------------------
Timer 0 etabliert die grundlegenden Zeitschlitze fr das System. 
Diese Routine enthlt alle wesentlichen, zeitunkritischen Ablufe, die zyklisch bearbeitet werden mssen.
--------------------------------------------------------------------------------------------------
*/
#ifdef _AVR_IOM16_H_
ISR(TIMER0_COMP_vect)
#endif
#ifdef _AVR_IOTN85_H_
ISR(TIMER0_COMPA_vect)
#endif
{		
	//#ifdef PWM_hardware
	//	sei(); //Hier verschachtelten Interrupt zulassen, da die PWM-Pulse asynchron auftreten.
	//#endif
	if (Idle.counter>Idle.max) 
		{
		Idle.max=Idle.counter;
		}
	else
		{
		if (Idle.counter<Idle.min)
			{
			Idle.min=Idle.counter;	
			} 
		}	
//#if LED_switch 
#if LED_max >0
	blinktimer--;
	if (blinktimer<LED_max)
		{LED_job(blinktimer);}
	
	if (blinktimer==0) 
		{blinktimer=blinktimer_max;}	
#endif

#ifdef PWM_software
#if PWM_max
			switch (PWM[0].State)
			{
				case 0:
				{
					if ((PINB & 1<<port_PWM1)!=0)
							{
							//Pulsanfang	
							PWM[0].Tick_cnt=0;
							PWM[0].State=1;	
							}
					break;
				}
				case 1:
				{
					if ((PINB & 1<<port_PWM1)!=0)	
						{
						PWM[0].Tick_cnt++;
						if (PWM[0].Tick_cnt==0x00)
							{
							PWM[0].State=0; //Fehlerhafter Puls oder Dauerplus	
							}	
						}
					else
						{
						//Pulsende
						PWM[0].Tick_value=PWM[0].Tick_cnt;
						PWM[0].State=0;
						}
					break;
				}
			}
#if PWM_max2
			switch (PWM[1].State)
			{
				case 0:
				{
					if ((PINB & 1<<port_PWM2)!=0)
							{
							//Pulsanfang	
							PWM[1].Tick_cnt=0;
							PWM[1].State=1;	
							}
					break;
				}
				case 1:
				{
					if ((PINB & 1<<port_PWM2)!=0)	
						{
						PWM[1].Tick_cnt++;
						if (PWM[1].Tick_cnt==0x00)
							{
							PWM[1].State=0; //Fehlerhafter Puls oder Dauerplus	
							}	
						}
					else
						{
						//Pulsende
						PWM[1].Tick_value=PWM[1].Tick_cnt;
						PWM[1].State=0;
						}
					break;
				}
			}
		
#endif
#endif
#endif
}

/*------------------------------------------------------------------------------------------------
Timer 1 wird als  schneller Timer benutzt, um PWM-Pulse zu vermessen. 
Ein berlauf in der Routine bedeutet, dass die Messung ber 255 Zyklen gedauert hat, und damit ungltig ist
--------------------------------------------------------------------------------------------------
*/
#ifdef PWM_hardware
#ifdef PWM_max
#ifdef _AVR_IOM16_H_
ISR(TIMER1_OVF_vect)
#endif
#ifdef _AVR_IOTN85_H_
ISR(TIMER1_OVF_vect)
#endif
{
	PCMSK &= ~(1<<PWM->Port_pin);//sensitiver Portpin wird wieder deaktiviert
	PWM->Error++; //Fehlmessung dokumentieren
	
	PWM_aktiv=0; //	Die Messung wird mit der 1. PWM reintialisiert
	PWM_ptr=&PWM[PWM_aktiv];
	PCMSK |= (1<<PWM_ptr->Port_pin); //Der sensitive Portpin wird aktiviert
}
#endif
#endif

#ifdef PWM_hardware
#ifdef PWM_max
#ifdef _AVR_IOM16_H_
ISR(PCINT0_vect)
#endif
#ifdef _AVR_IOTN85_H_
ISR(PCINT0_vect)
#endif
{
	if ((PINB & 1<<PWM_ptr->Port_pin)!=0)
	{
		//Steigende Flanke, die Messung beginnt
		GTCCR |= (1<<PSR1);// Vorteiler-Reset
		TCNT1=0x00;//Timer=0;
		TIMSK |= (1<<TOIE1); //Interrupt bei berlauf 		
	}
	else
	{		
		//Fallende Flanke, Messung beenden, Ergebnis sichern, neue PWM vorbereiten
		PWM_ptr->Tick_value=TCNT1; //Ergebnis zuweisen
		PCMSK &= ~(1<<PWM_ptr->Port_pin); //Den sensiblen Pin abschalten
		if (PWM_aktiv!= PWM_max-1)
		{
			PWM_aktiv++; //Nchste PWM vorbeiten
		}
		else
		{
			PWM_aktiv=0; //Zyklus beginnt bei PWM0
		}
		PWM_ptr=&PWM[PWM_aktiv]; //Pointer auf neue PWM-Messung
		PCMSK |= (1<<PWM_ptr->Port_pin);//Sensiblen Pin einschalten
		TIMSK &= ~(1<<TOIE1); //Interrupt fr Timer1 ausschalten (Pause dauert 200ms)				
	}
}
#endif
#endif

void PWM_init(void)
{
	#ifdef PWM_max
	uint8_t n;
	for(n=0;n<PWM_max;n++)
		{	
		PWM[n].State=0;
		PWM[n].Tick_value=0xFF;
		PWM[n].Tick_cnt=0;	
		if (n==0)
			{
			PWM[n].Port_pin=port_PWM1;	
			}
		else
			{
			#ifdef PWM_max2	
			PWM[n].Port_pin=port_PWM2;				
			#endif
			}
		}
	#ifdef eeprom_log	
	//void  eeprom_update_block (const void *__src, void *__dst, size_t __n) 	
	eeprom_update_block ((void *)&PWM[0],(void *)&EE_PWM1,sizeof(PWM[0]));	//prfen
	//EE_PWM1=PWM[0];
	//EE_PWM2=PWM[1];
	#endif
	
	#endif
	return;
}




int main(void)
{
	Idle.counter=0;
	Idle.min=0x2FFF;
	Idle.max=0;
	PORT_init();	
	LED_init();
	
	#ifdef PWM_max
	PWM_init();
	#endif
	
	//#ifdef Pegel_max
	//Pegel_init();
	//#endif
	
	Timer0_init();
	
	#ifdef PWM_max
	#ifdef PWM_hardware	
		Timer1_init();
		IRQonCHG_init();
	#endif	
	#endif
	
	//Initialisierung
	LED[0].Funktion=2;
	LED[1].Funktion=1;
	LED[2].Funktion=1;
	LED[3].Funktion=2;

    while(1)
    {		
		#ifdef PWM_max
		//Hardware: f=62500Hz 62,5<t<125 @100%
		//Software: f=33300Hz 31<t<62 @100%
		if (PWM[0].Tick_value>100) //=29..35%
			{
			//Oberes Drittel
			LED[0].Funktion=2;
			LED[1].Funktion=1;
			LED[2].Funktion=2;
			LED[3].Funktion=2;	
			}
		else
			{
			if (PWM[0].Tick_value<83)//-38..-33%
				{
				//Unteres Drittel
				LED[0].Funktion=0;
				LED[1].Funktion=0;
				LED[2].Funktion=0;
				LED[3].Funktion=0;					
				}
			else
				{
				//Mitte
				LED[0].Funktion=2;
				LED[1].Funktion=0;
				LED[2].Funktion=2;
				LED[3].Funktion=2;		
				}	
			}
		#endif
		
		#ifdef Pegel_max
		if (PINB & (1<< port_Pegel1))
				{
				//Ein=1
				LED[0].Funktion=2;
				LED[1].Funktion=1;
				LED[2].Funktion=0;
				LED[3].Funktion=2;
				}
			else
				{
				//Aus=0

				LED[0].Funktion=2;
				LED[1].Funktion=2;
				LED[2].Funktion=2;
				LED[3].Funktion=2;
				}
		#endif
		Idle.counter++;	
		_NOP();
		   
    }
}
